package org.dromara.elevator.service.impl;

import org.dromara.common.core.utils.MapstructUtils;
import org.dromara.common.core.utils.StringUtils;
import org.dromara.common.mybatis.core.page.TableDataInfo;
import org.dromara.common.mybatis.core.page.PageQuery;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import lombok.RequiredArgsConstructor;
import org.dromara.elevator.domain.ERelevancyCode;
import org.springframework.stereotype.Service;
import org.dromara.elevator.domain.bo.ERescueInfoBo;
import org.dromara.elevator.domain.vo.ERescueInfoVo;
import org.dromara.elevator.domain.ERescueInfo;
import org.dromara.elevator.mapper.ERescueInfoMapper;
import org.dromara.elevator.service.IERescueInfoService;

import java.util.List;
import java.util.Map;
import java.util.Collection;

/**
 * 救援站信息;Service业务层处理
 *
 * @author zy
 * @date 2024-09-03
 */
@RequiredArgsConstructor
@Service
public class ERescueInfoServiceImpl implements IERescueInfoService {

    private final ERescueInfoMapper baseMapper;

    /**
     * 查询救援站信息;
     *
     * @param id 主键
     * @return 救援站信息;
     */
    @Override
    public ERescueInfoVo queryById(Long id){
        return baseMapper.selectVoById(id);
    }

    /**
     * 分页查询救援站信息;列表
     *
     * @param bo        查询条件
     * @param pageQuery 分页参数
     * @return 救援站信息;分页列表
     */
    @Override
    public TableDataInfo<ERescueInfoVo> queryPageList(ERescueInfoBo bo, PageQuery pageQuery) {
        LambdaQueryWrapper<ERescueInfo> lqw = buildQueryWrapper(bo);
        Page<ERescueInfoVo> result = baseMapper.selectVoPage(pageQuery.build(), lqw);
        return TableDataInfo.build(result);
    }

    /**
     * 查询符合条件的救援站信息;列表
     *
     * @param bo 查询条件
     * @return 救援站信息;列表
     */
    @Override
    public List<ERescueInfoVo> queryList(ERescueInfoBo bo) {
        LambdaQueryWrapper<ERescueInfo> lqw = buildQueryWrapper(bo);
        return baseMapper.selectVoList(lqw);
    }

    private LambdaQueryWrapper<ERescueInfo> buildQueryWrapper(ERescueInfoBo bo) {
        Map<String, Object> params = bo.getParams();
        LambdaQueryWrapper<ERescueInfo> lqw = Wrappers.lambdaQuery();
        lqw.like(StringUtils.isNotBlank(bo.getName()), ERescueInfo::getName, bo.getName());
        lqw.eq(StringUtils.isNotBlank(bo.getAddress()), ERescueInfo::getAddress, bo.getAddress());
        lqw.eq(StringUtils.isNotBlank(bo.getPrincipal()), ERescueInfo::getPrincipal, bo.getPrincipal());
        lqw.eq(StringUtils.isNotBlank(bo.getPrincipalPhone()), ERescueInfo::getPrincipalPhone, bo.getPrincipalPhone());
        lqw.eq(StringUtils.isNotBlank(bo.getEmergency()), ERescueInfo::getEmergency, bo.getEmergency());
        lqw.eq(StringUtils.isNotBlank(bo.getEmergencyPhone()), ERescueInfo::getEmergencyPhone, bo.getEmergencyPhone());
        lqw.eq(StringUtils.isNotBlank(bo.getMaintenance()), ERescueInfo::getMaintenance, bo.getMaintenance());
        lqw.eq(StringUtils.isNotBlank(bo.getOrganization()), ERescueInfo::getOrganization, bo.getOrganization());
        lqw.eq(bo.getLng() != null, ERescueInfo::getLng, bo.getLng());
        lqw.eq(bo.getLat() != null, ERescueInfo::getLat, bo.getLat());
        lqw.eq(StringUtils.isNotBlank(bo.getArea()), ERescueInfo::getArea, bo.getArea());
        lqw.eq(StringUtils.isNotBlank(bo.getCertification()), ERescueInfo::getCertification, bo.getCertification());
        lqw.orderByDesc(ERescueInfo::getCreateTime);
        return lqw;
    }

    /**
     * 新增救援站信息;
     *
     * @param bo 救援站信息;
     * @return 是否新增成功
     */
    @Override
    public Boolean insertByBo(ERescueInfoBo bo) {
        ERescueInfo add = MapstructUtils.convert(bo, ERescueInfo.class);
        validEntityBeforeSave(add);
        boolean flag = baseMapper.insert(add) > 0;
        if (flag) {
            bo.setId(add.getId());
        }
        return flag;
    }

    /**
     * 修改救援站信息;
     *
     * @param bo 救援站信息;
     * @return 是否修改成功
     */
    @Override
    public Boolean updateByBo(ERescueInfoBo bo) {
        ERescueInfo update = MapstructUtils.convert(bo, ERescueInfo.class);
        validEntityBeforeSave(update);
        return baseMapper.updateById(update) > 0;
    }

    /**
     * 保存前的数据校验
     */
    private void validEntityBeforeSave(ERescueInfo entity){
        //TODO 做一些数据校验,如唯一约束
    }

    /**
     * 校验并批量删除救援站信息;信息
     *
     * @param ids     待删除的主键集合
     * @param isValid 是否进行有效性校验
     * @return 是否删除成功
     */
    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if(isValid){
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return baseMapper.deleteBatchIds(ids) > 0;
    }
}
